SystemOrganization addCategory: #'SCouchDB-JQuery'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Test'!
SystemOrganization addCategory: #'SCouchDB-JQuery-Lib'!

WAFileLibrary subclass: #JQCouchDevelopmentLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Lib'!

!JQCouchDevelopmentLibrary methodsFor: 'uploaded' stamp: 'JesusMari 7/21/2012 06:25'!
jquerycouchJs
	^ '// Licensed under the Apache License, Version 2.0 (the "License"); you may not
// use this file except in compliance with the License. You may obtain a copy of
// the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
// WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
// License for the specific language governing permissions and limitations under
// the License.

(function($) {
  $.couch = $.couch || {};

  function encodeDocId(docID) {
    var parts = docID.split("/");
    if (parts[0] == "_design") {
      parts.shift();
      return "_design/" + encodeURIComponent(parts.join('/'));
    }
    return encodeURIComponent(docID);
  };

  function prepareUserDoc(user_doc, new_password) {    
    if (typeof hex_sha1 == "undefined") {
      alert("creating a user doc requires sha1.js to be loaded in the page");
      return;
    }
    var user_prefix = "org.couchdb.user:";
    user_doc._id = user_doc._id || user_prefix + user_doc.name;
    if (new_password) {
      // handle the password crypto
      user_doc.salt = $.couch.newUUID();
      user_doc.password_sha = hex_sha1(new_password + user_doc.salt);
    }
    user_doc.type = "user";
    if (!!user_doc.roles) {
      user_doc.roles = [];
    }
    return user_doc;
  };

  var uuidCache = [];

  $.extend($.couch, {
    urlPrefix: '',
    activeTasks: function(options) {
      ajax(
        {url: this.urlPrefix + "/_active_tasks"},
        options,
        "Active task status could not be retrieved"
      );
    },

    allDbs: function(options) {
      ajax(
        {url: this.urlPrefix + "/_all_dbs"},
        options,
        "An error occurred retrieving the list of all databases"
      );
    },

    config: function(options, section, option, value) {
      var req = {url: this.urlPrefix + "/_config/"};
      if (section) {
        req.url += encodeURIComponent(section) + "/";
        if (option) {
          req.url += encodeURIComponent(option);
        }
      }
      if (value === null) {
        req.type = "DELETE";        
      } else if (value !!== undefined) {
        req.type = "PUT";
        req.data = toJSON(value);
        req.contentType = "application/json";
        req.processData = false;
      }

      ajax(req, options,
        "An error occurred retrieving/updating the server configuration"
      );
    },
    
    session: function(options) {
      options = options || {};
      $.ajax({
        type: "GET", url: this.urlPrefix + "/_session",
        complete: function(req) {
          var resp = $.httpData(req, "json");
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            alert("An error occurred getting session info: " + resp.reason);
          }
        }
      });
    },

    userDb : function(callback) {
      $.couch.session({
        success : function(resp) {
          var userDb = $.couch.db(resp.info.authentication_db);
          callback(userDb);
        }
      });
    },

    signup: function(user_doc, password, options) {      
      options = options || {};
      // prepare user doc based on name and password
      user_doc = prepareUserDoc(user_doc, password);
      $.couch.userDb(function(db) {
        db.saveDoc(user_doc, options);
      });
    },
    
    login: function(options) {
      options = options || {};
      $.ajax({
        type: "POST", url: this.urlPrefix + "/_session", dataType: "json",
        data: {name: options.name, password: options.password},
        complete: function(req) {
          var resp = $.httpData(req, "json");
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            alert("An error occurred logging in: " + resp.reason);
          }
        }
      });
    },
    logout: function(options) {
      options = options || {};
      $.ajax({
        type: "DELETE", url: this.urlPrefix + "/_session", dataType: "json",
        username : "_", password : "_",
        complete: function(req) {
          var resp = $.httpData(req, "json");
          if (req.status == 200) {
            if (options.success) options.success(resp);
          } else if (options.error) {
            options.error(req.status, resp.error, resp.reason);
          } else {
            alert("An error occurred logging out: " + resp.reason);
          }
        }
      });
    },

    db: function(name, db_opts) {
      db_opts = db_opts || {};
      var rawDocs = {};
      function maybeApplyVersion(doc) {
        if (doc._id && doc._rev && rawDocs[doc._id] && rawDocs[doc._id].rev == doc._rev) {
          // todo: can we use commonjs require here?
          if (typeof Base64 == "undefined") {
            alert("please include /_utils/script/base64.js in the page for base64 support");
            return false;
          } else {
            doc._attachments = doc._attachments || {};
            doc._attachments["rev-"+doc._rev.split("-")[0]] = {
              content_type :"application/json",
              data : Base64.encode(rawDocs[doc._id].raw)
            };
            return true;
          }
        }
      };
      return {
        name: name,
        uri: this.urlPrefix + "/" + encodeURIComponent(name) + "/",

        compact: function(options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_compact",
              data: "", processData: false
            },
            options,
            "The database could not be compacted"
          );
        },
        viewCleanup: function(options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_view_cleanup",
              data: "", processData: false
            },
            options,
            "The views could not be cleaned up"
          );
        },
        compactView: function(groupname, options) {
          $.extend(options, {successStatus: 202});
          ajax({
              type: "POST", url: this.uri + "_compact/" + groupname,
              data: "", processData: false
            },
            options,
            "The view could not be compacted"
          );
        },
        create: function(options) {
          $.extend(options, {successStatus: 201});
          ajax({
              type: "PUT", url: this.uri, contentType: "application/json",
              data: "", processData: false
            },
            options,
            "The database could not be created"
          );
        },
        drop: function(options) {
          ajax(
            {type: "DELETE", url: this.uri},
            options,
            "The database could not be deleted"
          );
        },
        info: function(options) {
          ajax(
            {url: this.uri},
            options,
            "Database information could not be retrieved"
          );
        },
        changes: function(since, options) {
          options = options || {};
          // set up the promise object within a closure for this handler
          var timeout = 100, db = this, active = true,
            listeners = [],
            promise = {
            onChange : function(fun) {
              listeners.push(fun);
            },
            stop : function() {
              active = false;
            }
          };
          // call each listener when there is a change
          function triggerListeners(resp) {
            $.each(listeners, function() {
              this(resp);
            });
          };
          // when there is a change, call any listeners, then check for another change
          options.success = function(resp) {
            timeout = 100;
            if (active) {
              since = resp.last_seq;
              triggerListeners(resp);
              getChangesSince();
            };
          };
          options.error = function() {
            if (active) {
              setTimeout(getChangesSince, timeout);
              timeout = timeout * 2;
            }
          };
          // actually make the changes request
          function getChangesSince() {
            var opts = $.extend({heartbeat : 10 * 1000}, options, {
              feed : "longpoll",
              since : since
            });
            ajax(
              {url: db.uri + "_changes"+encodeOptions(opts)},
              options,
              "Error connecting to "+db.uri+"/_changes."
            );
          }
          // start the first request
          if (since) {
            getChangesSince();
          } else {
            db.info({
              success : function(info) {
                since = info.update_seq;
                getChangesSince();
              }
            });
          }
          return promise;
        },
        allDocs: function(options) {
          var type = "GET";
          var data = null;
          if (options["keys"]) {
            type = "POST";
            var keys = options["keys"];
            delete options["keys"];
            data = toJSON({ "keys": keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + "_all_docs" + encodeOptions(options)
            },
            options,
            "An error occurred retrieving a list of all documents"
          );
        },
        allDesignDocs: function(options) {
          this.allDocs($.extend({startkey:"_design", endkey:"_design0"}, options));
        },
        allApps: function(options) {
          options = options || {};
          var self = this;
          if (options.eachApp) {
            this.allDesignDocs({
              success: function(resp) {
                $.each(resp.rows, function() {
                  self.openDoc(this.id, {
                    success: function(ddoc) {
                      var index, appPath, appName = ddoc._id.split('/');
                      appName.shift();
                      appName = appName.join('/');
                      index = ddoc.couchapp && ddoc.couchapp.index;
                      if (index) {
                        appPath = ['', name, ddoc._id, index].join('/');
                      } else if (ddoc._attachments && ddoc._attachments["index.html"]) {
                        appPath = ['', name, ddoc._id, "index.html"].join('/');
                      }
                      if (appPath) options.eachApp(appName, appPath, ddoc);
                    }
                  });
                });
              }
            });
          } else {
            alert("Please provide an eachApp function for allApps()");
          }
        },
        openDoc: function(docId, options, ajaxOptions) {
          options = options || {};
          if (db_opts.attachPrevRev || options.attachPrevRev) {
            $.extend(options, {
              beforeSuccess : function(req, doc) {
                rawDocs[doc._id] = {
                  rev : doc._rev,
                  raw : req.responseText
                };
              }
            });
          } else {
            $.extend(options, {
              beforeSuccess : function(req, doc) {
                if (doc["jquery.couch.attachPrevRev"]) {
                  rawDocs[doc._id] = {
                    rev : doc._rev,
                    raw : req.responseText
                  };
                }
              }
            });
          }
          ajax({url: this.uri + encodeDocId(docId) + encodeOptions(options)},
            options,
            "The document could not be retrieved",
            ajaxOptions
          );
        },
        saveDoc: function(doc, options) {
          options = options || {};
          var db = this;
          var beforeSend = fullCommit(options);
          if (doc._id === undefined) {
            var method = "POST";
            var uri = this.uri;
          } else {
            var method = "PUT";
            var uri = this.uri + encodeDocId(doc._id);
          }
          var versioned = maybeApplyVersion(doc);
          $.ajax({
            type: method, url: uri + encodeOptions(options),
            contentType: "application/json",
            dataType: "json", data: toJSON(doc),
            beforeSend : beforeSend,
            complete: function(req) {
              var resp = $.httpData(req, "json");
              if (req.status == 200 || req.status == 201 || req.status == 202) {
                doc._id = resp.id;
                doc._rev = resp.rev;
                if (versioned) {
                  db.openDoc(doc._id, {
                    attachPrevRev : true,
                    success : function(d) {
                      doc._attachments = d._attachments;
                      if (options.success) options.success(resp);
                    }
                  });
                } else {
                  if (options.success) options.success(resp);
                }
              } else if (options.error) {
                options.error(req.status, resp.error, resp.reason);
              } else {
                alert("The document could not be saved: " + resp.reason);
              }
            }
          });
        },
        bulkSave: function(docs, options) {
          var beforeSend = fullCommit(options);
          $.extend(options, {successStatus: 201, beforeSend : beforeSend});
          ajax({
              type: "POST",
              url: this.uri + "_bulk_docs" + encodeOptions(options),
              contentType: "application/json", data: toJSON(docs)
            },
            options,
            "The documents could not be saved"
          );
        },
        removeDoc: function(doc, options) {
          ajax({
              type: "DELETE",
              url: this.uri +
                   encodeDocId(doc._id) +
                   encodeOptions({rev: doc._rev})
            },
            options,
            "The document could not be deleted"
          );
        },
        bulkRemove: function(docs, options){
          docs.docs = $.each(
            docs.docs, function(i, doc){
              doc._deleted = true;
            }
          );
          $.extend(options, {successStatus: 201});
          ajax({
              type: "POST",
              url: this.uri + "_bulk_docs" + encodeOptions(options),
              data: toJSON(docs)
            },
            options,
            "The documents could not be deleted"
          );
        },
        copyDoc: function(docId, options, ajaxOptions) {
          ajaxOptions = $.extend(ajaxOptions, {
            complete: function(req) {
              var resp = $.httpData(req, "json");
              if (req.status == 201) {
                if (options.success) options.success(resp);
              } else if (options.error) {
                options.error(req.status, resp.error, resp.reason);
              } else {
                alert("The document could not be copied: " + resp.reason);
              }
            }
          });
          ajax({
              type: "COPY",
              url: this.uri + encodeDocId(docId)
            },
            options,
            "The document could not be copied",
            ajaxOptions
          );
        },
        query: function(mapFun, reduceFun, language, options) {
          language = language || "javascript";
          if (typeof(mapFun) !!== "string") {
            mapFun = mapFun.toSource ? mapFun.toSource() : "(" + mapFun.toString() + ")";
          }
          var body = {language: language, map: mapFun};
          if (reduceFun !!= null) {
            if (typeof(reduceFun) !!== "string")
              reduceFun = reduceFun.toSource ? reduceFun.toSource() : "(" + reduceFun.toString() + ")";
            body.reduce = reduceFun;
          }
          ajax({
              type: "POST",
              url: this.uri + "_temp_view" + encodeOptions(options),
              contentType: "application/json", data: toJSON(body)
            },
            options,
            "An error occurred querying the database"
          );
        },
        list: function(list, view, options) {
          var list = list.split('/');
          var options = options || {};
          var type = ''GET'';
          var data = null;
          if (options[''keys'']) {
            type = ''POST'';
            var keys = options[''keys''];
            delete options[''keys''];
            data = toJSON({''keys'': keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + ''_design/'' + list[0] +
                   ''/_list/'' + list[1] + '/' + view + encodeOptions(options)
              },
              options, ''An error occured accessing the list''
          );
        },
        view: function(name, options) {
          var name = name.split('/');
          var options = options || {};
          var type = "GET";
          var data= null;
          if (options["keys"]) {
            type = "POST";
            var keys = options["keys"];
            delete options["keys"];
            data = toJSON({ "keys": keys });
          }
          ajax({
              type: type,
              data: data,
              url: this.uri + "_design/" + name[0] +
                   "/_view/" + name[1] + encodeOptions(options)
            },
            options, "An error occurred accessing the view"
          );
        },
        getDbProperty: function(propName, options, ajaxOptions) {
          ajax({url: this.uri + propName + encodeOptions(options)},
            options,
            "The property could not be retrieved",
            ajaxOptions
          );
        },

        setDbProperty: function(propName, propValue, options, ajaxOptions) {
          ajax({
            type: "PUT", 
            url: this.uri + propName + encodeOptions(options),
            data : JSON.stringify(propValue)
          },
            options,
            "The property could not be updated",
            ajaxOptions
          );
        }
      };
    },

    encodeDocId: encodeDocId, 

    info: function(options) {
      ajax(
        {url: this.urlPrefix + "/"},
        options,
        "Server information could not be retrieved"
      );
    },

    replicate: function(source, target, ajaxOptions, repOpts) {
      repOpts = $.extend({source: source, target: target}, repOpts);
      if (repOpts.continuous) {
        ajaxOptions.successStatus = 202;
      }
      ajax({
          type: "POST", url: this.urlPrefix + "/_replicate",
          data: JSON.stringify(repOpts),
          contentType: "application/json"
        },
        ajaxOptions,
        "Replication failed"
      );
    },

    newUUID: function(cacheNum) {
      if (cacheNum === undefined) {
        cacheNum = 1;
      }
      if (!!uuidCache.length) {
        ajax({url: this.urlPrefix + "/_uuids", data: {count: cacheNum}, async: false}, {
            success: function(resp) {
              uuidCache = resp.uuids;
            }
          },
          "Failed to retrieve UUID batch."
        );
      }
      return uuidCache.shift();
    }
  });

  function ajax(obj, options, errorMessage, ajaxOptions) {
    options = $.extend({successStatus: 200}, options);
    ajaxOptions = $.extend({contentType: "application/json"}, ajaxOptions);
    errorMessage = errorMessage || "Unknown error";
    $.ajax($.extend($.extend({
      type: "GET", dataType: "json", cache : !!$.browser.msie,
      beforeSend: function(xhr){
        if(ajaxOptions && ajaxOptions.headers){
          for (var header in ajaxOptions.headers){
            xhr.setRequestHeader(header, ajaxOptions.headers[header]);
          }
        }
      },
      complete: function(req) {
        try {
          var resp = $.httpData(req, "json");
        } catch(e) {
          if (options.error) {
            options.error(req.status, req, e);
          } else {
            alert(errorMessage + ": " + e);
          }
          return;
        }
        if (options.ajaxStart) {
          options.ajaxStart(resp);
        }
        if (req.status == options.successStatus) {
          if (options.beforeSuccess) options.beforeSuccess(req, resp);
          if (options.success) options.success(resp);
        } else if (options.error) {
          options.error(req.status, resp && resp.error || errorMessage, resp && resp.reason || "no response");
        } else {
          alert(errorMessage + ": " + resp.reason);
        }
      }
    }, obj), ajaxOptions));
  }

  function fullCommit(options) {
    var options = options || {};
    if (typeof options.ensure_full_commit !!== "undefined") {
      var commit = options.ensure_full_commit;
      delete options.ensure_full_commit;
      return function(xhr) {
        xhr.setRequestHeader("X-Couch-Full-Commit", commit.toString());
      };
    }
  };

  // Convert a options object to an url query string.
  // ex: {key:''value'',key2:''value2''} becomes ''?key="value"&key2="value2"''
  function encodeOptions(options) {
    var buf = [];
    if (typeof(options) === "object" && options !!== null) {
      for (var name in options) {
        if ($.inArray(name, ["error", "success", "beforeSuccess", "ajaxStart"]) >= 0)
          continue;
        var value = options[name];
        if ($.inArray(name, ["key", "startkey", "endkey"]) >= 0) {
          value = toJSON(value);
        }
        buf.push(encodeURIComponent(name) + "=" + encodeURIComponent(value));
      }
    }
    return buf.length ? "?" + buf.join("&") : "";
  }

  function toJSON(obj) {
    return obj !!== null ? JSON.stringify(obj) : null;
  }

})(jQuery);
'! !

!JQCouchDevelopmentLibrary methodsFor: 'accessing' stamp: 'JesusMar 4/12/2012 00:05'!
selectorsToInclude
	^ #(jquerycouchJs)! !

!JQueryClass methodsFor: '*SCouchdb-JQuery' stamp: 'JesusMari 3/30/2012 23:17'!
couch
	^ self create: JQCouch! !

JQPlugin subclass: #JQCouch
	instanceVariableNames: 'couchFunction command database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery'!

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:47'!
activeTasks
self command:'activeTasks'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:23'!
allApps
self command:'allApps'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 14:30'!
allDbs
	self command:'allDbs'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:14'!
allDesignDocs
self command:'allDesignDocs'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 19:02'!
allDocs
self command:'allDocs'! !

!JQCouch methodsFor: 'accessing' stamp: 'JesusMari 4/3/2012 19:33'!
arguments
	| arguments jSonOptions|
	arguments := OrderedCollection new.
	jSonOptions:=Dictionary new.
	self options
		at: 'success'
		ifPresent: [ :value | jSonOptions at:'success' put: value ].
	self options
		at: 'eachApp'
		ifPresent: [ :value | jSonOptions at:'eachApp' put: value ].
	self options
		at: 'loginpassword'
		ifPresent: [ :value | jSonOptions at:'password' put: value ].
	self options
		at: 'name'
		ifPresent: [ :value | jSonOptions at:'name' put: value ].
	self options
		at: 'error'
		ifPresent: [ :value | jSonOptions at:'error' put: value ].
	self options
		at: 'reduce'
		ifPresent: [ :value | jSonOptions at:'reduce' put: value ].
	self options
		at: 'view'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'list'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'change'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'successUserDb'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'userDoc'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'password'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'replicateDb'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'replicateNewDb'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'doc'
		ifPresent: [ :value | arguments add: value ].						
	self options
		at: 'bulkDoc'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'mapFunction'
		ifPresent: [ :value | arguments add: value ].		
	self options
		at: 'reduceFunction'
		ifPresent: [ :value | arguments add: value ].						
	self options
		at: 'language'
		ifPresent: [ :value | arguments add: value ].	
							
	(jSonOptions size>0) ifTrue:[arguments add:jSonOptions].
	"this options after succcess...stupid order..."
	
	self options
		at: 'section'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'option'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'option-value'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'replicateTarget'
		ifPresent: [ :value | arguments add: value ].	
	self options
		at: 'beforeSend'
		ifPresent: [ :value | arguments add: value ].				
	^ arguments! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 19:37'!
beforeSend:aDocument 
"aDocument is a JSon doc with the beforeSend property that contains a jscript function"
	
|aDoc|
	aDoc:=Dictionary new.
	aDoc at:'beforeSend' put:( aDocument asFunction:#(xhr)).
	options at:'beforeSend' put:aDoc	
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 18:35'!
bulkRemove:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
|aDoc|
	aDoc:=Dictionary new.
	aDoc at:'docs' put: (aDocument).
	
	self command:'bulkRemove'.
	self optionAt: 'bulkDoc' put: aDoc.
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 18:41'!
bulkSave:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
|aDoc|
	aDoc:=Dictionary new.
	aDoc at:'docs' put: aDocument.
	
	self command:'bulkSave'.
	self optionAt: 'bulkDoc' put: aDoc.
! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 13:46'!
command
	^ command! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 13:46'!
command: anObject
	command := anObject! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:03'!
compact
self command:'compact'! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:13'!
compactView:aView
"aView name example: 'default/all'"
	
	self command:'compactView'.
	self optionAt: 'view' put: aView.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:57'!
config:aSection option:anOption
self command:'config'.
self options at:'section'put:aSection.
self options at:'option' put:anOption! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:58'!
config:aSection option:anOption value:aValue
self command:'config'.
self options at:'section'put:aSection.
self options at:'option' put:anOption.
self options at:'option-value' put:aValue! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 19:23'!
copyDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'copyDoc'.
	self optionAt: 'doc' put: aDocument.
! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/29/2012 22:38'!
couchFunction
	^ couchFunction! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 01:16'!
couchFunction: aFunction
(aFunction isKindOf: BlockClosure)
ifTrue:[	couchFunction:= ((aFunction value)greaseString)]
ifFalse:[	couchFunction := aFunction ]! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 3/31/2012 08:24'!
create
command:='create'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 08:22'!
database
	^ Array with:database! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/31/2012 08:23'!
database: anString
	database := anString.
	self couchFunction: [(JSStream on:'db') call:'' withArguments:(self database)].! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 3/31/2012 08:25'!
db:aDatabase

self database:aDatabase! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 19:21'!
drop
command:='drop'! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 19:20'!
forEachApp: anObject
	self optionAt: 'eachApp' put: (anObject asFunction:#(appName appPath ddoc)).
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 13:44'!
info
self command:'info'! !

!JQCouch methodsFor: 'accessing' stamp: 'JesusMari 4/5/2012 05:52'!
javascriptContentOn: aStream
	aStream
		javascript: self owner;
		nextPut: $.;
		nextPutAll: self method.
	
	couchFunction notNil ifTrue:[ aStream  nextPut:$.;nextPutAll:couchFunction].
	command notNil ifTrue:[ aStream nextPut:$. ;nextPutAll:command].
	self options size>0 ifTrue:[JSStream encodeArguments: self arguments on: aStream].
	aStream nextPut:$;
		
	! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 18:00'!
list:aView with:aList
"list a view with aList function'"
	
	self command:'list'.
	self optionAt: 'view' put: aView.
	self optionAt: 'list' put: aList.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:33'!
login:aUserName password:anString
"anUserName and password must be anString"

	self command:'login'.
	self optionAt: 'name' put: aUserName.
	self optionAt:'loginpassword' put: anString! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:45'!
logout
self command:'logout'! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 3/29/2012 23:19'!
method
	^ 'couch'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/5/2012 05:54'!
newUUID
self command:'newUUID()'.! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 4/3/2012 18:36'!
onChange: anObject
	self command:'changes().onChange'.
	self optionAt: 'change' put: (anObject asFunction:#(data)).
! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 3/31/2012 17:23'!
onError: anObject
	self optionAt: 'error' put: (anObject asFunction:#(status)).
! !

!JQCouch methodsFor: 'events' stamp: 'JesusMari 3/31/2012 14:40'!
onSuccess: anObject
	self optionAt: 'success' put: (anObject asFunction:#(data)).
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 17:45'!
openDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'openDoc'.
	self optionAt: 'doc' put: aDocument.
! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:33'!
query:mapFunction 
self query:mapFunction reduceFunction:'_count' language:'javascript'reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:22'!
query:mapFunction reduceFunction:reduceFunction 
self query:mapFunction reduceFunction:reduceFunction language:'javascript' reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:22'!
query:mapFunction reduceFunction:reduceFunction language:language 
self query:mapFunction reduceFunction:reduceFunction language:language reduce:false! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 21:24'!
query:mapFunction reduceFunction:reduceFunction language:language reduce:aBoolean
self command:'query'.
self optionAt: 'mapFunction' put: mapFunction.
self optionAt: 'reduceFunction' put: reduceFunction. 
self optionAt: 'language' put: language.
self optionAt: 'reduce' put: aBoolean! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:50'!
reduce:aBoolean
self optionAt: 'reduce' put: aBoolean! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 18:14'!
removeDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'removeDoc'.
	self optionAt: 'doc' put: aDocument.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/1/2012 09:09'!
replicate:aDatabase to:aNewDatabase createTarget:aBoolean
"create_target must be a Dictionary wuth the following entrances:
{create_target:true}"
|createTarget|
	createTarget:=Dictionary new.
	createTarget at:'create_target' put: aBoolean.

	self command:'replicate'.
	self optionAt: 'replicateDb' put: aDatabase.
	self optionAt: 'replicateNewDb' put: aNewDatabase.
	self optionAt: 'replicateTarget' put: createTarget.! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/2/2012 17:37'!
saveDoc:aDocument 
"aDocument is a JSon doc jscript reference or a json doc streamed as string or a variable reference"
	
	self command:'saveDoc'.
	self optionAt: 'doc' put: aDocument.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:44'!
session
self command:'session'! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 15:21'!
signUp:aUserName password:anString
"anUserDoc must be a Dictionary wuth the following entrances:
{_id:'org.couchdb.user:bob' , name:'bob'}"
|aUserDoc|
	aUserDoc:=Dictionary new.
	aUserDoc at:'_id' put: ('org.couchdb.user:',aUserName).
	aUserDoc at:'name' put:aUserName.
	self command:'signup'.
	self optionAt: 'userDoc' put: aUserDoc.
	self optionAt: 'password' put: anString.! !

!JQCouch methodsFor: 'private' stamp: 'JesusMari 4/5/2012 05:58'!
urlPrefix: anObject
		self couchFunction: [(JSStream on:'urlPrefix="',anObject,'"')].
	! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 3/31/2012 17:00'!
userDb:aFunction
self command:'userDb'.
self optionAt: 'successUserDb' put: (aFunction asFunction:#(data)).! !

!JQCouch methodsFor: 'databaseAPI' stamp: 'JesusMari 4/3/2012 17:34'!
view:aView
"aView name example: 'default/all'"
	
	self command:'view'.
	self optionAt: 'view' put: aView.
! !

!JQCouch methodsFor: 'serverAPI' stamp: 'JesusMari 4/3/2012 18:08'!
viewCleanup
self command:'viewCleanup'! !

JSObjectTest subclass: #JQueryCouchTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test'!

JQueryCouchTest subclass: #JQueryCouchDbTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SCouchDB-JQuery-Test'!

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/30/2012 23:16'!
couch
	^ self jQuery couch! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 00:13'!
couchDb
	^ self jQuery couchDb! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/5/2012 05:58'!
test0Couch
	self
		assert: (self jQuery couch)
		equals: self function , '.couch;'.
self
		assert: (self jQuery couch urlPrefix:'http://localhost:5984')
		equals: self function , '.couch.urlPrefix="http://localhost:5984";'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/5/2012 05:57'!
test0Database

	self
		assert: (self jQuery couch db:'test';create)
		equals: self function , '.couch.db("test").create;'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 14:58'!
test1Info

	self
		assert: (self jQuery couch info;onSuccess:'alert(data);')
		equals: self function , '.couch.info({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/5/2012 05:54'!
test2allDbs

	self
		assert: (self jQuery couch allDbs)
		equals: self function , '.couch.allDbs;'.
	self
		assert: (self jQuery couch allDbs;onSuccess:'alert(data);')
		equals: self function , '.couch.allDbs({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:23'!
test3SignUp
|user|

	
	self
		assert: (self jQuery couch signUp:'bob' password:'superpassword')
		equals: self function , '.couch.signup({"_id":"org.couchdb.user:bob","name":"bob"},"superpassword");'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:41'!
test4Login


	
	self
		assert: (self jQuery couch login:'bob' password:'superpassword';onSuccess:'done')
		equals: self function , '.couch.login({"success":function(data){done},"password":"superpassword","name":"bob"});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:44'!
test5session

	self
		assert: (self jQuery couch session;onSuccess:'alert(data);')
		equals: self function , '.couch.session({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:46'!
test6logout

	self
		assert: (self jQuery couch logout;onSuccess:'alert(data);')
		equals: self function , '.couch.logout({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:48'!
test7activeTasks

	self
		assert: (self jQuery couch activeTasks;onSuccess:'alert(data);')
		equals: self function , '.couch.activeTasks({"success":function(data){alert(data);}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 15:58'!
test8config

	self
		assert: (self jQuery couch config:'uuids'option:'algorithm';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm");'.
	self
		assert: (self jQuery couch config:'uuids'option:'algorithm'value:'sequential';onSuccess:'alert(data);')
		equals: self function , '.couch.config({"success":function(data){alert(data);}},"uuids","algorithm","sequential");'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 17:02'!
test9userDb

	self
		assert: (self jQuery couch userDb:'alert(data);')
		equals: self function , '.couch.userDb(function(data){alert(data);});'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 3/31/2012 17:06'!
testAnewUUID

	self
		assert: (self jQuery couch newUUID)
		equals: self function , '.couch.newUUID();'.
! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2012 09:20'!
testBReplicateDatabase

	self
		assert: (self jQuery couch replicate:'DB' to:'NEWDB' createTarget:true;onSuccess:'done';onError:'error')
		equals: self function , '.couch.replicate("DB","NEWDB",{"success":function(data){done},"error":function(status){error}},{"create_target":true});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2012 09:20'!
testCDatabaseCreate

	self
		assert: (self jQuery couch db:'test';create;onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").create({"success":function(data){done},"error":function(status){error}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/1/2012 09:21'!
testDDatabaseInfo

	self
		assert: (self jQuery couch db:'test';info;onSuccess:'done')
		equals: self function , '.couch.db("test").info({"success":function(data){done}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 17:38'!
testEsaveDoc

	self
		assert: (self jQuery couch db:'test';saveDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").saveDoc("aDoc",{"success":function(data){done},"error":function(status){error}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 18:00'!
testFopenDoc

	self
		assert: (self jQuery couch db:'test';openDoc:'d12ee5ea1df6baa2b06451f44a019ab9';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").openDoc("d12ee5ea1df6baa2b06451f44a019ab9",{"success":function(data){done},"error":function(status){error}});'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 18:15'!
testGremoveDoc

	self
		assert: (self jQuery couch db:'test';removeDoc:'aDoc';onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").removeDoc("aDoc",{"success":function(data){done},"error":function(status){error}});'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 18:50'!
testHbulkSave

	self
		assert: (self jQuery couch db:'test';bulkSave:(JSStream on:'aDoc');onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkSave({"docs":aDoc},{"success":function(data){done},"error":function(status){error}});'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 18:55'!
testIbulkRemove

	self
		assert: (self jQuery couch db:'test';bulkRemove:(JSStream on:'aDoc');onSuccess:'done';onError:'error')
		equals: self function , '.couch.db("test").bulkRemove({"docs":aDoc},{"success":function(data){done},"error":function(status){error}});'.! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 19:08'!
testJallDocs

	self
		assert: (self jQuery couch db:'test';allDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDocs({"success":function(data){done}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 17:18'!
testKallDesignDocs

	self
		assert: (self jQuery couch db:'test';allDesignDocs;onSuccess:'done')
		equals: self function , '.couch.db("test").allDesignDocs({"success":function(data){done}});'! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/2/2012 21:39'!
testKquery

	self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}});'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}});'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}});'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}});'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 19:20'!
testLallApps

	self
		assert: (self jQuery couch db:'test';allApps;forEachApp:('console.log(appName+" "+appPath+" "+ddoc');onSuccess:'done')
		equals: self function , '.couch.db("test").allApps({"success":function(data){done},"eachApp":function(appName,appPath,ddoc){console.log(appName+" "+appPath+" "+ddoc}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 17:19'!
testMquery

self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},"_count","javascript",{"reduce":false,"success":function(data){done}});'.
		
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc));onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"javascript",{"reduce":false,"success":function(data){done}});'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk';onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":false,"success":function(data){done}});'.
self
		assert: (self jQuery couch db:'test';query:('emit();' asFunction:#(doc)) reduceFunction:('_avg' asFunction:#(doc)) language:'smalltalk' reduce:true;onSuccess:'done')
		equals: self function , '.couch.db("test").query(function(doc){emit();},function(doc){_avg},"smalltalk",{"reduce":true,"success":function(data){done}});'		! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 17:51'!
testOview

	self
		assert: (self jQuery couch db:'test';view:('default/all');onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").view("default/all",{"reduce":false,"success":function(data){done},"error":function(status){err}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:02'!
testPlist

	self
		assert: (self jQuery couch db:'test';list:('default/all') with:'all';onSuccess:'done';onError:'err';reduce:false)
		equals: self function , '.couch.db("test").list("default/all","all",{"reduce":false,"success":function(data){done},"error":function(status){err}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:06'!
testQcompact

	self
		assert: (self jQuery couch db:'test';compact;onSuccess:'done')
		equals: self function , '.couch.db("test").compact({"success":function(data){done}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:08'!
testRviewCleanup

	self
		assert: (self jQuery couch db:'test';viewCleanup;onSuccess:'done')
		equals: self function , '.couch.db("test").viewCleanup({"success":function(data){done}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:13'!
testScompactView

	self
		assert: (self jQuery couch db:'test';compactView:'default';onSuccess:'done')
		equals: self function , '.couch.db("test").compactView("default",{"success":function(data){done}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 18:40'!
testTchange

	self
		assert: (self jQuery couch db:'test';onChange:'done')
		equals: self function , '.couch.db("test").changes().onChange(function(data){done});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 19:22'!
testUdrop

	self
		assert: (self jQuery couch db:'test';drop;onSuccess:'done')
		equals: self function , '.couch.db("test").drop({"success":function(data){done}});'.
		
	! !

!JQueryCouchDbTest methodsFor: 'as yet unclassified' stamp: 'JesusMari 4/3/2012 19:36'!
testVcopyDoc

	self
		assert: (self jQuery couch db:'test';copyDoc:'11111';onSuccess:'done';onError:'err';beforeSend:'send')
		equals: self function , '.couch.db("test").copyDoc("11111",{"success":function(data){done},"error":function(status){err}},{"beforeSend":function(xhr){send}});'.
		
	! !

!JQueryCouchTest class methodsFor: 'testing' stamp: 'JesusMari 3/30/2012 23:13'!
isAbstract
	^ self name = #JQueryTest! !

!JQueryCouchTest class methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
packageNamesUnderTest
	^ #('JQuery-Core')! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
function
	"Answers the name of the jQuery function. This can be either '$' or 'jQuery' or any other user chosen name. This makes sure the tests run in any case."

	^ JQuery functionName! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery
	^ JQueryClass context: self renderContext! !

!JQueryCouchTest methodsFor: 'accessing' stamp: 'JesusMari 3/30/2012 23:13'!
jQuery: anObject
	^ self jQuery with: anObject! !
